/*
 * detect.c
 *
 * Created: 2016-06-02 14:24:53
 *  Author: dsosnowski
 */ 


#define F_CPU 16000000UL
#include <avr/io.h>
#include <avr/interrupt.h>
#include <inttypes.h>
#include <util/delay.h>
#include <avr/wdt.h>
#include <avr/sleep.h>
#include <avr/pgmspace.h>

#include "hard.h"
#include "ultra.h"
#include "detect.h"


#define DETECT_PWM_RANGE		100


struct {
	char time;
	char range;
} analog;


//---------------------------------------------------
void DetectInit(void){
	DIDR0 = (1<<WAVE_PIN | 1<<RANGE_PIN | 1<<TIME_PIN);
}

//---------------------------------------------------
void DetectWaveScanInit(void){
	ADCSRA = (1<<ADEN | 1<<ADPS2 | 1<<ADPS1 | 1<<ADPS0);
	ADMUX = (0<<REFS1 | 0<<REFS0 | WAVE_PIN);
	ADCSRB = 0;
	ADCSRA |= (1<<ADSC);	
	while (ADCSRA & (1<<ADSC));
	ADCSRA = (1<<ADEN | 1<<ADSC | 1<<ADATE | 1<<ADPS2 | 1<<ADPS1 | 1<<ADPS0);
}

//---------------------------------------------------
void DetectWaveScanStop(void){
	ADCSRA = (1<<ADEN | 0<<ADSC | 0<<ADATE | 1<<ADPS2 | 1<<ADPS1 | 1<<ADPS0);	
}

//---------------------------------------------------
uint16_t DetectWaveScanGet(void){
	return ADC;
}

//---------------------------------------------------
char DetectTimeGet(void) {
	return analog.time;
}

//---------------------------------------------------
char DetectRangeGet(void) {
	return analog.range;
}

//---------------------------------------------------
uint16_t DetectTime(void){
	ADCSRA = (1<<ADEN | 1<<ADPS2 | 1<<ADPS1 | 1<<ADPS0);
	ADMUX = (0<<REFS1 | 0<<REFS0 | TIME_PIN);
	ADCSRB = 0;
	ADCSRA |= (1<<ADSC);
	while (ADCSRA & (1<<ADSC));
	analog.time = (ADC >> 2);
	return analog.time;
}

//---------------------------------------------------
uint16_t DetectRange(void){
	ADCSRA = (1<<ADEN | 1<<ADPS2 | 1<<ADPS1 | 1<<ADPS0);
	ADMUX = (0<<REFS1 | 0<<REFS0 | RANGE_PIN);
	ADCSRB = 0;
	ADCSRA |= (1<<ADSC);
	while (ADCSRA & (1<<ADSC));
	analog.range = (ADC >> 2);
	return analog.range;
}